/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Drag de Go code.
 *
 * The Initial Developer of the Original Code is
 * Yukichi Kamata.
 * Portions created by the Initial Developer are Copyright (C) 2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either of the GNU General Public License Version 2 or later (the "GPL"),
 * or the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//////////// Drag and Dorp bserver: replace contentAreaDNDObserver with it. ///////////////////

var DragdeGoDNDObserver = {
	StartAlready:false,
	OverAlready:false,
	Dropped:false,
	drag_data:null,
	timer:null,
	eTimer:null,
	
	onDragStart: function(e, aXferData, dragAction){
		if(this.StartAlready || this.OverAlready) this.unInit();
		this.drag_data = new ddg_Data(e);
		this.StartAlready = true;
		if(this.drag_data.showTooltip)
			ddg_Tooltip.Init(e);
		
		function ddg_Data(e){
			this.target = null;
			this.text = null;
			this.url = null;
			this.src = null;
			this.startX = this.lastX = e.pageX;
			this.startY = this.lastY = e.pageY;
			this.action = [];
			this.delayCnt = 0;
			this.stayCnt = 0;
			this.tipChanged = false;
			this.currAction = null;
			this.sourceNode = null;
			with(ddg_Preferences.Prefs){
				this.enableTipChange = enableToChangeUrlGest;
				this.showTooltip = showTooltip;
				if(this.showTooltip){
					this.tipStyle = tipStyle;
					this.moveTooltip = moveEnable;
				}else{
					this.tipStyle = [];
					this.moveTooltip = false;
				}
			}
		}
	},
	
	onDragOver: function(e, aFlavour, aDragSession){
		var SourceNode = aDragSession.sourceNode;
		if(!this.StartAlready){
			return;
		}else if(!SourceNode || (aDragSession.sourceDocument != e.view.document)){// && SourceNode.id && SourceNode.id != "content")){
			this.unInit();
		}else if(!this.OverAlready){
			if (!aDragSession.canDrop && /^(img|input|textarea)$/i.test(SourceNode.localName))
				this.enableDropOnImg();
				
			try{
				var transData = ddgUtils.getTransferData(aFlavour.contentType, aDragSession);
				var selection = DragdeGo.SelectedText(e);
				var DragData = transData.dataObj.value.
							QueryInterface(nsCI.nsISupportsString).
							data.substring(0, transData.len.value).split("\n");
				var uri = selection ? selection : DragData[0];
				
				with(this.drag_data){
					sourceNode = SourceNode;
					if(SourceNode.localName == "IMG"){
						action = ddg_Preferences.Prefs.Iaction;
						if(action[0] != 4){
							target = "images";
							uri = SourceNode.parentNode.href ? SourceNode.parentNode.href : SourceNode.src;
							url = ddg_Security.checkURI(uri);
							text = DragData[1] ? DragData[1] : null;
							src = SourceNode.src;
						}
					}else if(selection && !DragdeGo.forceAsURL(uri)){
						action = ddg_Preferences.Prefs.Taction;
						if(action[0] != 4){
							target = "text";
							url = src = null;
							text = uri;
						}
					}else if(!selection && /([^\/]+\.(xpi|jar))$/.test(uri)){
						action = ddg_Preferences.Prefs.Xaction;
						if(action[0] != 4){
							target = "xpis";
							text = RegExp.$1;
							url = src = ddg_Security.checkURI(uri);
						}
					}else{
						action = ddg_Preferences.Prefs.Laction;
						if(action[0] != 4){
							target = "links";
							url = src = ddg_Security.checkURI(uri);
							text = DragData[1] ? DragData[1] : null;
						}
					}
				}
				this.OverAlready = true;
			}catch(e){
				ddgUtils.Log('onDragOver: fails to get Data from this DragSession.\n' + e);
				this.unInit();
			}
		}
	},
	
	unInit: function(){
		ddg_Tooltip.unInit();
		with(this){
			if(timer) clearTimeout(timer);
			if(eTimer) clearTimeout(eTimer);
			timer = eTimer = null;
			OverAlready = StartAlready = Dropped = false;
			drag_data = null;
		}
	},
	
	checkSession : function(){
		with(DragdeGoDNDObserver){
			if(timer) clearTimeout(timer);
			timer = null;
			if(!Dropped){
				var currSession = Components.classes["@mozilla.org/widget/dragservice;1"].
									getService(nsCI.nsIDragService).getCurrentSession();
				if(currSession)
					timer = setTimeout(checkSession, 500);
				else
					unInit();
			}
		}
	},
	
	onDrop: function (e, aDropData, aDragSession){
/***************Drag and Drop from Content area.*********************/
		if(this.StartAlready){
			this.Dropped = true;
			with(this.drag_data){
				lastX = e.clientX;
				lastY = e.clientY;
				tipChanged = e.ctrlKey == true ? true : tipChanged;
			}
			if(ddg_Preferences.Prefs.EnableTimeout){
				window.addEventListener('mousedown', DragdeGoDNDObserver.TimeoutHandler.onMouseDown, true);
				this.eTimer = setTimeout(function(aData) {
					window.removeEventListener('mousedown', DragdeGoDNDObserver.TimeoutHandler.onMouseDown, true);
					DragdeGo.DoGesture(aData);
					DragdeGoDNDObserver.unInit();
				}, ddg_Preferences.Prefs.TimeoutPeriod, this.drag_data);
			}else{
				DragdeGo.DoGesture(this.drag_data);
				DragdeGoDNDObserver.unInit();
			}
			/*Firefox seems to never delete Image temp-files produced by drag_and_drop.
			 *So delete it. Bug#245861
			 */
			if(aDragSession.isDataFlavorSupported("application/x-moz-file")){
				var transData = ddgUtils.getTransferData("application/x-moz-file", aDragSession);
				if(transData.dataObj.value){
					var tempFile = transData.dataObj.value.QueryInterface(nsCI.nsIFile);
					if(tempFile.exists()) {setTimeout(function(){try{
							if(tempFile.exists()) tempFile.remove(false);}catch(e){ddgUtils.Log("Fails to delete image ;" + e);}}, 1000);
					}
				}
			}
			
/**********  Drag and Drop from other.  *************/
		}else{
			var url = transferUtils.retrieveURLFromData(aDropData.data, aDropData.flavour.contentType);
			url = ddg_Security.checkURI(url);
			if(url){
				var Data = {url:url, currAction:"go-c", tipChanged:false};
				if(aDragSession.sourceNode){
					Data.currAction = ddg_Preferences.Prefs.OpenIn[1];
					ddg_ges.Open(Data);
				}else if((e.target.localName == "INPUT") && (e.target.type == "file")){
					try{
						var ioService = Components.classes["@mozilla.org/network/io-service;1"]
									.getService(nsCI.nsIIOService);
						var fileHandler = ioService.getProtocolHandler("file")
									.QueryInterface(nsCI.nsIFileProtocolHandler);
 						
						var aFile = fileHandler.getFileFromURLSpec(url);
						e.target.value = aFile.path;
					}catch(e){
						alert("Drag de Go fails to Get File Path");
					}
				}else if((/(^http|\.(txt|ini|xml|s?html?|sgml?|css|js|jpg|png|gif|bmp)$)/i.test(url))
							|| ((/[\/]$/i.test(url)) && !(/\.lnk[\/]$/i.test(url)))){
					Data.currAction = ddg_Preferences.Prefs.OpenIn[0];
					ddg_ges.Open(Data);
				}else{
					ddg_ges.Open(Data);
				}
			}
			this.unInit();
		}
		e.preventDefault();
		e.stopPropagation();
	},
	
	enableDropOnImg : function(){
		nsDragAndDrop.checkCanDrop = function (e, aDragDropObserver) {
			if (!this.mDragSession)
				this.mDragSession = this.mDragService.getCurrentSession();
			if (!this.mDragSession) return false;
		
			with(this.mDragSession){
				if (sourceNode && (/^(img|input|textarea)$/i.test(sourceNode.localName)))
					canDrop = true;
				else
					canDrop = sourceNode != e.target;
				if ("canDrop" in aDragDropObserver)
					canDrop &= aDragDropObserver.canDrop(e, this.mDragSession);
			}
			return true;
		}
	},
	
	onDragExit: function(e, aDragSession){
		this.timer = setTimeout(DragdeGoDNDObserver.checkSession, 1000);
	},
	
	canDrop : function(e, aDragSession){
		if(this.timer){
			clearTimeout(this.timer);
			this.timer = null;
		}
		var retVal = true;
		if(e.type == "dragover" && this.OverAlready){
			with(this.drag_data){
				var DropTo = e.target.localName;
				if(action[0] == 4){
					retVal = (DropTo == "INPUT" || DropTo == "TEXTAREA");
				}else{
					var currentX = e.pageX;
					var currentY = e.pageY;
					if(lastX == currentX && lastY == currentY){
						if(stayCnt <= 100) stayCnt++;
						delayCnt = delayCnt > 10000 ? 1000 : delayCnt + 5;
					}else{
						stayCnt = 0;
						delayCnt = delayCnt > 10000 ? 1000 : delayCnt + 1;
						tipChanged = false;
					}
					lastX = currentX;
					lastY = currentY;
					var direction = DragdeGo.Direction(this.drag_data);
					currAction = action[direction];
					if(DropTo == "INPUT" || DropTo == "TEXTAREA"){
						ddg_Tooltip.hide();
						retVal = true;
					}else{
						if(/^go-/.test(currAction) && !url)
							currAction = "do-nothing";
						if(currAction == "do-nothing")
							retVal = false;
						if(stayCnt >= 20){
							if(enableTipChange && /^go-/.test(currAction)){
								var Message = ddg_StringS.getByName("g.go.changed");
								if(!tipChanged) ddg_Tooltip.changeText(Message);
								tipChanged = true;
							}else{
								if(/^search-[fhc]/.test(currAction)){
									var Message = ddg_StringS.getByName("g."+ RegExp.lastMatch) + decodeURIComponent(RegExp.rightContext);
								}else
									var Message = ddg_StringS.getByName("g."+ currAction);
							}
						}else{
							if(/^search-[fhc]/.test(currAction)){
								var Message = ddg_StringS.getByName("g."+ RegExp.lastMatch) + decodeURIComponent(RegExp.rightContext);
							}else
								var Message = ddg_StringS.getByName("g."+ currAction);
						}
						ddgUtils.sBarMessage(Message);
						if(showTooltip && delayCnt >= tipStyle[4])
							ddg_Tooltip.show(e ,Message, this.drag_data);
					}
				}
			}
		}
		return retVal;
	},
	
	TimeoutHandler : {
		onMouseDown : function(e){
			if(e.button == ddg_Preferences.Prefs.DragContextButton)
				ddg_ges.dragContext.show(DragdeGoDNDObserver.drag_data);
			DragdeGoDNDObserver.unInit();
			window.removeEventListener('mousedown', DragdeGoDNDObserver.TimeoutHandler.onMouseDown, true);
			window.addEventListener('click', DragdeGoDNDObserver.TimeoutHandler.onMouseUp, true);
			ddgUtils.sBarMessage(ddg_StringS.getByName("gesture.aborted"), 2000);
		},
		
		onMouseUp : function(e){
			e.preventDefault();
			e.stopPropagation();
			window.removeEventListener('click', DragdeGoDNDObserver.TimeoutHandler.onMouseUp, true);
		}
	},
	
	getSupportedFlavours: function (){
		var flavourSet = new FlavourSet();
		flavourSet.appendFlavour("text/x-moz-url");
		flavourSet.appendFlavour("text/unicode");
		flavourSet.appendFlavour("application/x-moz-file", "nsIFile");
		flavourSet.appendFlavour("text/html");
		return flavourSet;
	}
};

/**************************************
* Global
***************************************/

var ddg_StatusBar;
var DragdeGo = {
	onLoad: function(){
		window.addEventListener('unload', DragdeGo.unLoad, false);
		window.removeEventListener('load', DragdeGo.onLoad, false);
		getBrowser().addEventListener('draggesture', function(event) {nsDragAndDrop.startDrag(event, DragdeGoDNDObserver);} , true);
		getBrowser().setAttribute('ondragover', 'nsDragAndDrop.dragOver(event, DragdeGoDNDObserver)');
		getBrowser().setAttribute('ondragdrop', 'nsDragAndDrop.drop(event, DragdeGoDNDObserver)'); 
		getBrowser().setAttribute('ondragexit', 'nsDragAndDrop.dragExit(event, DragdeGoDNDObserver)');
		ddg_StatusBar = document.getElementById("statusbar-display");
		ddg_Preferences.loadPrefs();
		DragdeGo.updateState();
	},
	
	unLoad: function(){
		getBrowser().removeEventListener('draggesture', function(event) {nsDragAndDrop.startDrag(event, DragdeGoDNDObserver);} , true);
		window.removeEventListener('unload', DragdeGo.unLoad, false);
	},
	
	DoGesture: function (aData){
		//ddgUtils.Log(aData.text +"\n"+ aData.url +"\n"+ aData.src +"\n"+ aData.startX +"\n"+ aData.startY);
		switch (aData.currAction) {
			case "conquery" :
				ddg_ges.Conquery(aData);break;
			case "paste-searchbar" :
				ddg_ges.searchBox.update(aData, 1);break;
			case "delete-searchbar" :
				ddg_ges.searchBox.update(aData, 0);break;
			case "paste-findbar" :
				ddg_findBar(aData, 1);break;
			case "delete-findbar" :
				ddg_findBar(aData, 0);break;
			case "install-addon" :
				ddg_ges.InstallXpi(aData);break;
			case "dragContext":
				ddg_ges.dragContext.show(aData);break;
			case "saveMenu":
				ddg_ges.saveMenu.show(aData);break;
			case "flashGot":
				ddg_ges.flashgot(aData);break;
			default: 
				if(/^search-[fch]/.test(aData.currAction))
					ddg_ges.Search(aData);
				else if(/^go-[fch]/.test(aData.currAction))
					ddg_ges.Open(aData);
				else if(/^save-df-/.test(aData.currAction))
					ddg_ges.SaveDf(aData);
				else if(/^save-(link|addon|Img|text)$/.test(aData.currAction))
					ddg_ges.SaveAs(aData);
		}
	},

	Direction : function(aData){
		var X = aData.lastX - aData.startX;
		var Y = aData.lastY - aData.startY;
		if(aData.action[0] == 0)
			return (Math.abs(X) - Math.abs(Y))>0 ? (X>0 ? 1 : 2) : (Y>0 ? 3 : 4) ;
		else if(aData.action[0] == 1)
			return Y>0 ? 3 : 4 ;
		else if(aData.action[0] == 2)
			return X>0 ? 1 : 2 ;
		else
			return 4;
	},

/******************************
*    Internal Functions
********************************/

	SelectedText : function(e) {
		var node = e.target;
		if ((node.localName == "TEXTAREA") ||
				(node.localName == "INPUT" && node.type == "text"))
			return node.value.substring(node.selectionStart, node.selectionEnd);
		else
			return document.commandDispatcher.focusedWindow.getSelection().toString();
	},

	forceAsURL : function(auri){
		var DomainName = /(\w+(\-+\w+)*\.)+\w{2,7}/ ;
		var HasSpace = /\S\s+\S/;
		var HasTwOrSlash = /(www|\/)/;
		return DomainName.test(auri) && !HasSpace.test(auri) && HasTwOrSlash(auri);
	},

	OpenCfg:function(){
		var CfgWin = ddgUtils.MostRecentWindow('mozilla:ddg-prefs');
		if(CfgWin) CfgWin.focus();
		else window.openDialog("chrome://dragdego/content/prefs/mainPref.xul", "chrome,centerscreen,resizable,dialog=yes");
	},

	updateState : function(){
		document.getElementById('ddg-cfg-menu').hidden = !ddg_Preferences.Prefs.ShowOptionMenu;
	}
}
window.addEventListener('load', DragdeGo.onLoad, false);
